# all files / ol/ image.js

73.08% Statements 38/52
33.33% Branches 4/12
83.33% Functions 5/6
73.08% Lines 38/52

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    1591×

    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    27×

    27×

    27×
    27×

    27×

    27×

    27×

    27×

    1×

    1×
    7×

    7×

    1×

    1×
    4×

    4×
    4×
    4×

    1×
    9×
    9×
    9×
    9×

    9×

    9×

    1×
    4×

    4×
    4×

     goog.provide('ol.Image');

    goog.require('goog.asserts');
    goog.require('goog.events');
    goog.require('goog.events.EventType');
    goog.require('goog.object');
    goog.require('ol.ImageBase');
    goog.require('ol.ImageState');
    goog.require('ol.extent');

    /**
     * @constructor
     * @extends {ol.ImageBase}
     * @param {ol.Extent} extent Extent.
     * @param {Array.<number>|undefined} resolution Resolution.
     * @param {number} pixelRatio Pixel ratio.
     * @param {Array.<ol.Attribution>} attributions Attributions.
     * @param {string} src Image source URI.
     * @param {?string} crossOrigin Cross origin.
     * @param {ol.ImageLoadFunctionType} imageLoadFunction Image load function.
     */
    ol.Image = function(extent, resolution, pixelRatio, attributions, src,
        crossOrigin, imageLoadFunction) {

      goog.base(this, extent, resolution, pixelRatio, ol.ImageState.IDLE,
          attributions);

      /**
       * @private
       * @type {string}
       */
      this.src_ = src;

      /**
       * @private
       * @type {Image}
       */
      this.image_ = new Image();
      Iif (crossOrigin) {
        this.image_.crossOrigin = crossOrigin;
      }

      /**
       * @private
       * @type {Object.<number, Image>}
       */
      this.imageByContext_ = {};

      /**
       * @private
       * @type {Array.<goog.events.Key>}
       */
      this.imageListenerKeys_ = null;

      /**
       * @protected
       * @type {ol.ImageState}
       */
      this.state = ol.ImageState.IDLE;

      /**
       * @private
       * @type {ol.ImageLoadFunctionType}
       */
      this.imageLoadFunction_ = imageLoadFunction;

    };
    goog.inherits(ol.Image, ol.ImageBase);

    /**
     * Get the HTML image element (may be a Canvas, Image, or Video).
     * @param {Object=} opt_context Object.
     * @return {HTMLCanvasElement|Image|HTMLVideoElement} Image.
     * @api
     */
    ol.Image.prototype.getImage = function(opt_context) {
      Iif (opt_context !== undefined) {
        var image;
        var key = goog.getUid(opt_context);
        if (key in this.imageByContext_) {
          return this.imageByContext_[key];
        } else if (goog.object.isEmpty(this.imageByContext_)) {
          image = this.image_;
        } else {
          image = /** @type {Image} */ (this.image_.cloneNode(false));
        }
        this.imageByContext_[key] = image;
        return image;
      } else {
        return this.image_;
      }
    };

    /**
     * Tracks loading or read errors.
     *
     * @private
     */
    ol.Image.prototype.handleImageError_ = function() {
      this.state = ol.ImageState.ERROR;
      this.unlistenImage_();
      this.changed();
    };

    /**
     * Tracks successful image load.
     *
     * @private
     */
    ol.Image.prototype.handleImageLoad_ = function() {
      Iif (this.resolution === undefined) {
        this.resolution = [
          ol.extent.getWidth(this.extent) / this.image_.width,
          ol.extent.getHeight(this.extent) / this.image_.height
        ];
      }
      this.state = ol.ImageState.LOADED;
      this.unlistenImage_();
      this.changed();
    };

    /**
     * Load not yet loaded URI.
     */
    ol.Image.prototype.load = function() {
      Eif (this.state == ol.ImageState.IDLE) {
        this.state = ol.ImageState.LOADING;
        this.changed();
        goog.asserts.assert(!this.imageListenerKeys_,
            'this.imageListenerKeys_ should be null');
        this.imageListenerKeys_ = [
          goog.events.listenOnce(this.image_, goog.events.EventType.ERROR,
              this.handleImageError_, false, this),
          goog.events.listenOnce(this.image_, goog.events.EventType.LOAD,
              this.handleImageLoad_, false, this)
        ];
        this.imageLoadFunction_(this, this.src_);
      }
    };

    /**
     * Discards event handlers which listen for load completion or errors.
     *
     * @private
     */
    ol.Image.prototype.unlistenImage_ = function() {
      goog.asserts.assert(this.imageListenerKeys_,
          'this.imageListenerKeys_ should not be null');
      this.imageListenerKeys_.forEach(goog.events.unlistenByKey);
      this.imageListenerKeys_ = null;
    };